# This file is a template, and might need editing before it works on your project.
# Official language image. Look for the different tagged releases at:
image: python:3.9
  - apt-get install -y git curl python-pip python-dev python3-dev build-essential doxygen


# Pick zero or more services to be used on all builds.
# Only needed when using a docker container to run your tests in.
# Check out: http://docs.gitlab.com/ce/ci/docker/using_docker_images.html#what-is-service
#services:
#  - mysql:latest
#  - redis:latest
#  - postgres:latest

# conda39:
#   image: continuumio/miniconda3:latest
#   before_script:
#     - git config --global user.email "gitlabcicd@totalgood.com"
#     - git config --global user.name "GitLab CI for qary"
#     - apt-get update
#     - apt-get install -y git curl python3-pip python3-dev python3-dev build-essential doxygen
#     # - conda update -n base -c defaults conda
#     - conda env create -n qaryenv -f scripts/environment.yml
#     - conda activate qaryenv || source activate qaryenv
#     - python -v
#     # - python -m pip install --upgrade poetry
#     - poetry install
#   script:
#     # - find . | grep -E "(/__pycache__$|\.pyc$|\.pyo$)" | xargs rm -rf
#     - conda activate qaryenv
#     - which python
#     - export PY_IGNORE_IMPORTMISMATCH=1
#     - pytest

venvpipeditable39:
  image: python:3.9
  before_script:
    - git config --global user.email "gitlabcicd@totalgood.com"
    - git config --global user.name "GitLab CI for qary"
    - apt-get update -qy
    - apt-get install -y git curl python3-dev build-essential graphviz doxygen
    - python3.9 -m venv venv
    - source venv/bin/activate
    - which python
    - python -v
    - source scripts/install_editable.sh
    - python -m pip install .
  script:
    # - find . | grep -E "(/__pycache__$|\.pyc$|\.pyo$)" | xargs rm -rf
    - export PY_IGNORE_IMPORTMISMATCH=1
    - pytest

venvpip39:
  image: python:3.9
  before_script:
    - git config --global user.email "gitlabcicd@totalgood.com"
    - git config --global user.name "GitLab CI for qary"
    - apt-get update -qy
    - apt-get install -y git curl python3-dev build-essential graphviz doxygen
    - python -v
    - python3.9 -m venv venv
    - source venv/bin/activate
    - which python
    - python -v
    - python -m pip install .
  script:
    # - find . | grep -E "(/__pycache__$|\.pyc$|\.pyo$)" | xargs rm -rf
    - export PY_IGNORE_IMPORTMISMATCH=1
    - pytest


venvpoetry39:
  image: python:3.9
  before_script:
    - git config --global user.email "gitlabcicd@totalgood.com"
    - git config --global user.name "GitLab CI for qary"
    - apt-get update -qy
    - apt-get install -y git curl python3-dev build-essential graphviz doxygen
    - python -v
    - python3.9 -m venv venv
    - source venv/bin/activate
    - which python
    - python -v
    - pip install --upgrade poetry
    - poetry update
    - poetry install
  script:
    # - find . | grep -E "(/__pycache__$|\.pyc$|\.pyo$)" | xargs rm -rf
    - export PY_IGNORE_IMPORTMISMATCH=1
    - pytest


pages:
  image: python:3.7
  stage: deploy
  script:
    # m2r+mistune versions [required by Sphinx](https://github.com/CrossNox/m2r2/issues/40)
    - pip install sphinx recommonmark m2r==0.2.1 mistune==0.8.4
    - cd docs
    - make html
    - cp -r _build/html ../public
  artifacts:
    paths:
      - public/
  only:
    - main

